%% 5.1

h = figure,

[gridX, gridY] = ndgrid([-1:0.01:1]);
UC_ind = (gridX.^2 + gridY.^2) >= 1;

colormap(jet),

% x_1

Z1 = sqrt(1-gridX.^2-gridY.^2);
Z1 (UC_ind) = NaN;

subplot(2,4,1),
surf(gridX,gridY,Z1,Z1,'EdgeAlpha',0), axis equal,
set(gca, 'CLim', [-1, 1]),
title('Coordinate map x_1')

% x_2

Z2 = -sqrt(1-gridX.^2-gridY.^2);
Z2 (UC_ind) = NaN;

subplot(2,4,2),
surf(gridX,gridY,Z2,Z2,'EdgeAlpha',0), axis equal,
set(gca, 'CLim', [-1, 1]),
title('Coordinate map x_2')

% x_3

[gridX, gridY] = ndgrid([-10:0.1:10]);

X = ( 2 .* gridX ./ (gridX.^2 + gridY.^2 + 1) );
Y = ( 2 .* gridY ./ (gridX.^2 + gridY.^2 + 1) );
Z3 = ( (gridX.^2 + gridY.^2 - 1) ./ (gridX.^2 + gridY.^2 + 1) );

subplot(2,4,3),
surf(X, Y, Z3,Z3,'EdgeAlpha',0), axis equal,
set(gca, 'CLim', [-1, 1]),
title('Coordinate map x_3')

% x_4

[gridX, gridY] = ndgrid([0.01:0.01:1], [0.01:0.01:2*pi]);

Z4 = ( cos(gridX*pi) );
X = ( sin(gridX*pi) .* cos(gridY) );
Y = ( sin(gridX*pi) .* sin(gridY) );

subplot(2,4,4),
surf(X, Y, Z4, Z4,'EdgeAlpha',0), axis equal,
set(gca, 'CLim', [-1, 1]),
title('Coordinate map x_4')

%% 5.3

subplot(2,4,5),
imagesc(Z1), axis equal, axis off, 
set(gca, 'CLim', [-1, 1]),
title('[-1:1]x[-1:1]')

subplot(2,4,6),
imagesc(Z2), axis equal, axis off,
set(gca, 'CLim', [-1, 1]),
title('[-1:1]x[-1:1]')

subplot(2,4,7),
imagesc(Z3), axis equal, axis off,
set(gca, 'CLim', [-1, 1]),
title('[-10:10]x[-10:10]')

subplot(2,4,8),
imagesc(Z4), axis off,
set(gca, 'CLim', [-1, 1])
,
title('[-1:1]x[0:2pi]')